
// MetaQuote [ MQ 4 ] 
//    IDENTIFICATION DIVISION    
//


                    #define   ProgramName         "The Multi-Oscllator iPack"
                    #define   SystemSymbol        "TMO"
                    #define   Author              "Keit Thomas Largo"
                    #define   eMail               "CockeyedCowboy@HotMail.com"
                    #define   LicenseTo           "WinSoft Technology "
                    #define   ModuleType          "Indicator Pack File"
                    #define   DateWriten          "01/25/2009"
                    #define   VersionNumber       "2.00.01"
                    #define   LastUpDate          "01-25-2009"
                    #define   VersionRelease      "Beta Version"
                    #define   ProgramLanguage     "MetaQuote  MQL v4.00, b220"
                    #define   ScriptLanguage      "Removed"
                    #define   SecurityLevel       "Open Source"
                    #define   Documentation       "None"
                    #define   CopyRight           "FreeWare"




/* 	 COPYRIGHT NOTICE: 


                   This indicator code is a re-writen and reorginized script of an
                   existing indicator code found on the ForexTSD Forum. Originally
                   coded by cja. The code was entitled "Multi_Oscillator_v1.mq4".
                   All credit for the code goes to the original author. Additional
                   information on the author can be found on the his Web Site;
                   "http://cjatradingtools.com/". All changes and additions that I
                   have incorporated into cja code is freely given to the members
                   of the ForexTSD Forum, as well.


                                  ~~~ Keit Thomas Largo ~~~




//  WARRANTIES: 


                    WinSoft Technology, EXPRESSLY DISCLAIMS ANY WARRANTY for this
                    SOFTWARE. The SOFTWARE along with any related documentation 
                    is provided  " AS IS " without any waranties, either express or
                    implied, including, the implied warranties or merchantability
                    or fitness for any particular purpose. The entire risk arising
                    out of usage or performance of this SOFTWARE re-mains with the
                    user. WinSoft Technology assumes NO LIABILITY FOR DAMAGES OR
                    LOSS whatsoever arising out of the use of, or inability of use,
                    of this SOFTWARE.



//
//    ENVIRONMENTAL DIVISION    
//*/

    //  FILE LINKAGE SECTION: 


                 // #include    <Implement/Language Script/Lore Language  v2.60>
                 // #include    <Implement/MetaQuote  v4.00/RunTime Components>




        // <<<< Property Segment >>>> 


                        #property          indicator_buffers    7
                        #property          indicator_separate_window




    //  DEFINED CONSTANT SECTION: 


                        #define            UnknownErrorFlag      -999
                        #define            NoDrawing               12
                        #define            MidPoint                 0
                        #define            All                      0
                        #define            Denied                   0
                        #define            Granted                  1

                        #define            LONG                   1.5
                        #define            FLAT                     0
                        #define            SHORT                 -1.5

                        #define            UpTrend                  2
                        #define            UpTrendPullBack          1
                        #define            UnDetermined             0
                        #define            DownTrendRailly         -1
                        #define            DownTrend               -2

                        #define            RelativeStrengthIndex    1
                        #define            CommodityChannelIndex    2
                        #define            MoneyFlowIndex           3
                        #define            SlowStochastic           4
                        #define            DeMarkerIndicator        5
                        #define            WilliamPercentR          6
                        #define            RelativeVigorIndex       7
                        #define            VolatilityIndicator      8
                        #define            MacdIndicator            9
                        #define            PriceAnalysis           10

                        #define            Quarry                   0
                        #define            Primary                  1
                        #define            Secondary                2
                        #define            LineOne                  3
                        #define            LineTwo                  4
                        #define            LineThree                5
                        #define            LineFour                 6


    //  EXTERN INPUT PARAMETER SECTION: 


        extern string _________SYSTEM_SETTINGS  =   " Indicator Control Parameters";

        extern int               Indicator_Quary    =   0;   
        extern int               Indicator_Lock     =   0,  Viewing_Time       =   2;

        // <<<< Input Legend Segment1 >>>> 

        extern string        _INDICATOR_LOCK_LEGEND  =  " LOCK INDICATOR VIEW",

                                    Shows_AllI_ndicators       =  "   0",
                                    Relative_Strength_Index    =  "   1",
                                    Commodity_Channel_Index    =  "   2",
                                    Money_Flow_Index           =  "   3",
                                    Slow_Stochastic            =  "   4",
                                    DeMarker_Indicator         =  "   5",
                                    William_Percent_R          =  "   6",
                                    Relative_Vigor_Index       =  "   7",
                                    Volatility_Indicator       =  "   8",
                                    MACD_Indicator             =  "   9",
                                    Price_Analysis             =  "  10";
         //---

        extern string ____________INDICATOR__1     =   " Relative Strength Index";
           extern int               RSI_Period         =  13,    RSI_PriceMode     =   0;

        extern string ____________INDICATOR__2     =   " Commodity Channel Index";
           extern int               CCI_Period         =  13,    CCI_PriceMode     =   0;

        extern string ____________INDICATOR__3     =   " Money Flow Index";
           extern int               MFI_Period         =  13; 

        extern string ____________INDICATOR__4     =   " Slow Stochastic";
           extern int               Sto_Percent_K      =  28,    Sto_Percent_D     =   5,
                                    Sto_Slowing         =   5,    Sto_Price_Mode    =   0,
                                    Sto_MA_Method      =   0;

        extern string ____________INDICATOR__5     =   " DeMarker Indicator";
           extern int               DEM_Period         =  13; 

        extern string ____________INDICATOR__6     =   " William Percent R";
           extern int               WPR_Period         =  13; 

        extern string ____________INDICATOR__7     =   " Relative Vigor Index";
           extern int               RVI_Period         =  13; 

        extern string ____________INDICATOR__8     =   " Volatility Indicator (ATR)";
           extern int               ATR_Period         =  13,    ATR_MA_Method     =   0;

        extern string ____________INDICATOR__9     =   " MCAD Indicator";
           extern int               Short_MA_Period    =  12,    Long_MA_Period    =  26,
                                    Signal_Period      =   9,    Price_Mode        =   0;
          extern bool               MACD_Histogram     =  True;

          extern string _________SYSTEM_SETTINGS.1.1 =   " SYSTEM  Parameters 1.1.";

           extern int               Chart_Bars_Drawn   = 500; 


        // <<<< Input Legend Segment1.1 >>>> 

        extern string      
                           __________METHOD_LEGEND  =  " MOVING AVERAGE METHOD",

                            MODE_SMA.        =  "  0 = Simple Moving Average",
                            MODE_EMA.        =  "  1 = Exponential Moving Average",
                            MODE_SMMA.       =  "  2 = Smoothed Moving Average",
                            MODE_LWMA.       =  "  3 = Linear Weighted Moving Average",

                         _____________PRICE_LEGEND  =  " PRICE STUDY MODE",
                            PRICE_CLOSE.     =  "  0 = Close Price",
                            PRICE_OPEN.      =  "  1 = Open Price",
                            PRICE_HIGH.      =  "  2 = High Price",
                            PRICE_LOW.       =  "  3 = Low Price",
                            PRICE_MEDIAN.    =  "  4 = Median Price, (high+low)/2",
                            PRICE_TYPICAL.   =  "  5 = Typical Price, (high+low+close)/3",
                            PRICE_WEIGHTED.  =  "  6 = Weighted Price, (hi+low+cl+cl)/4";




    //  DEFAULT PARAMETER SECTION: 


        bool
            DeBugMessages       =  False, // Turns on and off functions for code debuging.
            ViewIndicators      =   True, // Turns on and off indicator viewing capabilities.
            ViewAnalitical      =  False, // Turns on Analitical indicators for viewing.
            AutoDrawWindow      =  False, // Draws Indicators based on number of bars in view.
            AllowEAsAccess      =  False; // Will Allow EAs Access to iPack File.


        int
            IndicatorQuary      =    0, // Used for EA access to indicators in this file.
            IndicatorsExposed   =  All, // Which indicator to be displayed in chart plain.
            AvailableIndicators =    9, // Number of Technical indicators that are available.
            AvailableAnalitical =    1, // Number of Analitical indicators availabel for viewing.
            IndicatorViewTime   =   10, // Time indicator will be visiable on chart. In Seconds.
            ChartDrawingBars    =  500; // The amount of bars indicator will drawn on charts.


        double
            NoTradeZone         =   25; // Below this ATR pip amount no trades will be taken. 




    //  GLOBAL SCOPE VARIABLES SECTION: 


            bool
                DataValidated       =  False;

            int
                BarsCounted         =  0,          BarsToCalculate     =  0,
                ChartingPeriod      =  0,          StartDrawing        =  0,
                DataHistory         =  0,          RightsToTrading     =  0,
                LockIndicatorView   =  0;


            double
                HighToday           =  0,          LowToday            =  0,
                CloseYesterday      =  0,
                PointSize           =  0,          PipCount            =  0,
                ErrorFound          =  0,          ConveyMessage       =  0;


            string
                IndicatorName       =  "",         TradedCurrency      =  "";




    //  GLOBAL SCOPE ARRAYS SECTION: 


            double
                RelativeStrength    [ ],           CommodityChannel    [ ],
                MoneyFlow           [ ],
                Stochastic          [ ],           StochasticSignal    [ ],
                DeMarker            [ ],           PercentR            [ ],
                RelativeVigor       [ ],           RelativeVigorSignal [ ],
                PriceVolatility     [ ],           VolatilityDalta     [ ],
                MacdLine            [ ],           MacdSignal          [ ],
                UpHistogram         [ ],           DownHistogram       [ ],
                TrendDalta          [ ],
                TrendAnalysis       [ ],           SignalAnalysis      [ ],

                PrimaryIndicator    [ ],           SecondaryIndicator  [ ],
                QuarryIndicator     [ ],           LevelOne            [ ],
                LevelTwo            [ ],           LevelThree          [ ],
                LevelFour           [ ],

                ErrorLevel          [ ],           EraseBuffer         [ ];




     //  MODULE DECLARATION SECTION: 




//
//    CONFIGURATION DIVISION    
void init(){//

    //  INITIALIZATION SECTION: 

        // <<<< Data Iitialization Segment >>>> 

            RightsToTrading    =  Denied;
            IndicatorQuary     =  Indicator_Quary;
            LockIndicatorView  =  Indicator_Lock;
            IndicatorViewTime  =  Viewing_Time;
            ChartDrawingBars   =  Chart_Bars_Drawn + 5;
            TradedCurrency     =  Symbol();
            ChartingPeriod     =  Period();
            PointSize          =  MarketInfo( TradedCurrency, 11 );
            PipCount           =  MarketInfo( TradedCurrency, 17 );
            IndicatorName      =  "    Is not In Viewing Mode";
            NoTradeZone        =  NoTradeZone * PointSize;
            StartDrawing       =  Bars - ChartDrawingBars;




        // <<<< Buffer Iitialization Segment >>>> 

            IndicatorBuffers( 7 );

            SetIndexDrawBegin( Quarry,    StartDrawing );
            SetIndexDrawBegin( Primary,   StartDrawing );
            SetIndexDrawBegin( Secondary, StartDrawing );
            SetIndexDrawBegin( LineOne,   StartDrawing );
            SetIndexDrawBegin( LineTwo,   StartDrawing );
            SetIndexDrawBegin( LineThree, StartDrawing );
            SetIndexDrawBegin( LineFour,  StartDrawing );

            SetIndexBuffer( Quarry,    QuarryIndicator );
            SetIndexBuffer( Primary,   PrimaryIndicator );
            SetIndexBuffer( Secondary, SecondaryIndicator );
            SetIndexBuffer( LineOne,   LevelOne );
            SetIndexBuffer( LineTwo,   LevelTwo );
            SetIndexBuffer( LineThree, LevelThree );
            SetIndexBuffer( LineFour,  LevelFour );

            IndicatorDigits( MarketInfo( TradedCurrency, 12 ) );
            IndicatorShortName( ProgramName + " FATIAL ERROR: (see Expert Log )" );




        // <<<< Array Iitialization Segment >>>> 

            CreateCustomBuffer( RelativeStrength,     ChartDrawingBars );
            CreateCustomBuffer( CommodityChannel,     ChartDrawingBars );
            CreateCustomBuffer( MoneyFlow,            ChartDrawingBars );
            CreateCustomBuffer( Stochastic,           ChartDrawingBars );
            CreateCustomBuffer( StochasticSignal,     ChartDrawingBars );
            CreateCustomBuffer( DeMarker,             ChartDrawingBars );
            CreateCustomBuffer( PercentR,             ChartDrawingBars );
            CreateCustomBuffer( RelativeVigor,        ChartDrawingBars );
            CreateCustomBuffer( RelativeVigorSignal,  ChartDrawingBars );
            CreateCustomBuffer( PriceVolatility,      ChartDrawingBars );
            CreateCustomBuffer( VolatilityDalta,      ChartDrawingBars );
            CreateCustomBuffer( MacdLine,             ChartDrawingBars );
            CreateCustomBuffer( MacdSignal,           ChartDrawingBars );
            CreateCustomBuffer( UpHistogram,          ChartDrawingBars );
            CreateCustomBuffer( DownHistogram,        ChartDrawingBars );
            CreateCustomBuffer( TrendDalta,           ChartDrawingBars );
            CreateCustomBuffer( TrendAnalysis,        ChartDrawingBars );
            CreateCustomBuffer( SignalAnalysis,       ChartDrawingBars );
            CreateCustomBuffer( ErrorLevel,           ChartDrawingBars );
            CreateCustomBuffer( EraseBuffer,          ChartDrawingBars );




    //  FILTERS, RESTRAINS AND DEVIATIONS SECTION: 


        if( ViewIndicators && ViewAnalitical )
                AvailableIndicators  =  AvailableIndicators + AvailableAnalitical;


        if( LockIndicatorView > 0 && LockIndicatorView <= AvailableIndicators )
            IndicatorsExposed  =  LockIndicatorView;




    //  DATA VALIDATION SECTION: 


        if( ! DataValidated ) {
            if( ! AllowEAsAccess && IndicatorQuary != 0 ) {
                Print( ProgramName, ", EA ACCESS ERROR: \'Indicator_Quary\', Variable ",
                       "Is Not A User Controlable Parameter. Return Its Value To ",
                       "Zero." );
             } else if( AllowEAsAccess && ( IndicatorQuary < 0 ||
                        IndicatorQuary > ( AvailableIndicators + AvailableAnalitical ))) {
                Print( ProgramName, ", EA ACCESS ERROR: An overflow error has occured. ",
                       "Requested IndicatorQuary[ ", IndicatorQuary, " ] is out of range. ",
                       "It cannot be lower then Zero nor higher then ",
                       ( AvailableIndicators + AvailableAnalitical ));
            } else if( ! ViewIndicators && ! AllowEAsAccess ) {
                Print( ProgramName, ", SYSTEM DEFAULT ERROR: Both \'ViewIndicators\' And ",
                       "\'AllowEAsAccess\' Set To FALSE. There Is No Permitted Usage." );
            } else if( ViewAnalitical && ! ViewIndicators ) {
                Print( ProgramName, ", SYSTEM DEFAULT ERROR: You Cannot View Analitical ",
                       "Data Without First Turning On View Indicators. Change System ",
                       "Settings Accordingly. ");
            } else if( Bars < ChartDrawingBars ) {
                Print( ProgramName, ", SYSTEM ERROR: This Code Needs A Minimum Of ",
                       ChartDrawingBars, " Bars Of History. Try Lowering The ",
                       "\'Chart_Bars_Drawn\' Paramter." );
            } else if( Sto_Price_Mode > 1 || Sto_Price_Mode < 0 ) {
                Print( ProgramName, ", DATA ENTRY ERROR: \'Sto Price Mode\' Input Parameter ",
                       "Value Must Be Set To Either 1 Or 0. [ ", Sto_Price_Mode,
                       "  Is Not Allowed ]." );
            } else if( LockIndicatorView < 0 || LockIndicatorView > AvailableIndicators ) {
                Print( ProgramName, ", DATA ENTRY ERROR: The Input For \'Indicator_Lock\'[ ",
                       LockIndicatorView, " ] Is Out Of Range. Input Has To be A",
                       " Number 0 To ", AvailableIndicators, "." );
            } else {
                DataValidated  =  True;
                ConveyMessage  =  102.00;
                Print( "DATA VALIDATION: Was Completed Successfully. ", ProgramName,
                       " Has Been En-Abled." );
            } // End If, Bars:
        } // End If, DataValidated:




    //  INDICATOR INITIALIZATION SECTION: 


        if( DataValidated ) {
            if( ! ViewIndicators ) {
                Print( ProgramName, ", Is Set For Access By Expert Advisors Only. ",
                       "Indicator Chart And Analitical Data Viewing Is Not Granted." );
            } else if( ! AllowEAsAccess ) {
                if( ViewAnalitical )
                    Print( ProgramName, ", Is Set For Full Indicator And Analitical ",
                           "Chart Viewing. Expert Advisor Access Has Not Been Granted." );
                else
                    Print( ProgramName, ", Is Set For Indicator Only Chart Viewing. ",
                       "Analitical Data And Expert Advisor Access Is Not Granted." );
            } else {
                if( ViewAnalitical )
                    Print( ProgramName, ", Is Set For Full Indicator And Analitical ",
                           "Chart Viewing With Full Access Granted Expert Advisors " );
                else
                    Print( ProgramName, ", Is Set For Indicator Chart Viewing And Full ",
                       "Access Granted Expert Advisors, No Analitical Data Available " );
            } // End If, ViewIndicators:
            RightsToTrading  =  Granted;
        } else {
            ConveyMessage  =  110.34;
            Print( "Data Validation Failure: ", ProgramName, ", SYSTEM HALTED: It ",
                   "Can Not Be Activated Until The Condition Below Is Corrected." );
        } // End If, DataValidated:




return;}//
//    CODING DIVISION    
void start(){//

// LABEL 000  LOCAL SCOPE DATA ORGANIZATION: 

            int
                LoopIndex           =  0,           LoopCountATR        =  0;




// LABEL 100  TRADING RIGHTS ALLOWED: 

            if( RightsToTrading == Denied ) {
                ConveyMessage  =  101.00;
                if( DeBugMessages )
                    Print ( "SYSTEM HALTED: ", ProgramName, " Has Been Terminated. " );
                return;   // RD!{deinit( Halted )}:
            } // End If, RightsToTrading:




// LABEL 200  MARKET ANALYSIS: 




// LABEL 300  INDICATOR DEVELOPMENT: 

    // <<<< Segment 310 >>>> 
        // Reset buffers and line levels to default Empty state with no drawing:

            SetIndexStyle( Quarry,     NoDrawing );
            SetIndexStyle( Primary,    NoDrawing );
            SetIndexStyle( Secondary,  NoDrawing );
            SetIndexStyle( LineOne,    NoDrawing );
            SetIndexStyle( LineTwo,    NoDrawing );
            SetIndexStyle( LineThree,  NoDrawing );
            SetIndexStyle( LineFour,   NoDrawing );

            IndicatorShortName( ProgramName + "    " + IndicatorName );

            FillBuffer( QuarryIndicator,    EraseBuffer, ChartDrawingBars );
            FillBuffer( PrimaryIndicator,   EraseBuffer, ChartDrawingBars );
            FillBuffer( SecondaryIndicator, EraseBuffer, ChartDrawingBars );
            FillBuffer( LevelOne,           EraseBuffer, ChartDrawingBars );
            FillBuffer( LevelTwo,           EraseBuffer, ChartDrawingBars );
            FillBuffer( LevelThree,         EraseBuffer, ChartDrawingBars );
            FillBuffer( LevelFour,          EraseBuffer, ChartDrawingBars );




    // <<<< Segment 320 >>>> 
        // Determines bars to calculate.

            BarsCounted  =  IndicatorCounted();
            if( BarsCounted > 0 ) {
                BarsCounted  =  BarsCounted - 1;
                if( BarsCounted >= ChartDrawingBars )
                    BarsCounted  =  ChartDrawingBars;
            } else if( BarsCounted < 0 ) {
                return;
            } // End If, BarsCounted:

            BarsToCalculate  =  Bars - BarsCounted;
            LoopCountATR     =  BarsToCalculate;




// LABEL 400  INDICATOR INDEX CONSTRUCTION: 

    // <<<< Segment 410 >>>> 
        // Code Segment To Construction All Basic Indicators.

            for( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

                RelativeStrength[ LoopIndex ]  =
                    iRSI( TradedCurrency, ChartingPeriod, RSI_Period, RSI_PriceMode, LoopIndex );

                CommodityChannel[ LoopIndex ]  =
                    iCCI( TradedCurrency, ChartingPeriod, CCI_Period, CCI_PriceMode, LoopIndex );

                MoneyFlow[ LoopIndex ]  =
                    iMFI( TradedCurrency, ChartingPeriod, MFI_Period, LoopIndex );

                Stochastic[ LoopIndex ]  =
                    iStochastic( TradedCurrency, ChartingPeriod, Sto_Percent_K, Sto_Percent_D,
                                Sto_Slowing, Sto_MA_Method, Sto_Price_Mode, MODE_MAIN, LoopIndex );

                StochasticSignal[ LoopIndex ]  =
                    iStochastic( TradedCurrency, ChartingPeriod, Sto_Percent_K, Sto_Percent_D,
                                Sto_Slowing, Sto_MA_Method, Sto_Price_Mode, MODE_SIGNAL, LoopIndex );

                DeMarker[ LoopIndex ]  =
                    iDeMarker( TradedCurrency, ChartingPeriod, DEM_Period, LoopIndex );

                PercentR[ LoopIndex ]  =
                    iWPR( TradedCurrency, ChartingPeriod, WPR_Period, LoopIndex );

                RelativeVigor[ LoopIndex ]  =
                    iRVI( TradedCurrency, ChartingPeriod, RVI_Period, MODE_MAIN, LoopIndex );

                RelativeVigorSignal[ LoopIndex ]  =
                    iRVI( TradedCurrency, ChartingPeriod, RVI_Period, MODE_SIGNAL, LoopIndex );

            } // End For Loop, LoopIndex:




    // <<<< Segment 420 >>>> 
        // Calculates A Short Period Average True Range For Determining Price Volatility. 

        while( LoopCountATR >= 0 ) {
            HighToday       =  High[ LoopCountATR ];
            LowToday        =  Low[ LoopCountATR ];
            CloseYesterday  =  Close[ LoopCountATR + 1 ];

                if( LoopCountATR == Bars - 1 ) {
                    VolatilityDalta[ LoopCountATR ]  =  HighToday - LowToday;
                } else {
                    VolatilityDalta[ LoopCountATR ]  =
                        MathMax( HighToday, CloseYesterday ) - MathMin( LowToday, CloseYesterday );
                } // End If, LoopCountATR:

            LoopCountATR  =  LoopCountATR - 1;

        } // End While Loop, LoopCounterATR:


        for( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

            PriceVolatility[ LoopIndex ]  =
                iMAOnArray( VolatilityDalta, 0, ATR_Period, 0, ATR_MA_Method, LoopIndex );

        } // End For Loop, LoopIndex:




    // <<<< Segment 430 >>>> 
        // Creates a MACD indicator, with option of typical lines or histogram. 

        for ( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

            MacdLine[ LoopIndex ]  =
                iMACD( TradedCurrency, ChartingPeriod, Short_MA_Period,
                        Long_MA_Period, Signal_Period, Price_Mode, MODE_MAIN, LoopIndex); 

            MacdSignal[ LoopIndex ]  =
                iMACD( TradedCurrency, ChartingPeriod, Short_MA_Period,
                        Long_MA_Period, Signal_Period, Price_Mode, MODE_SIGNAL, LoopIndex ); 

        } // End For Loop, LoopIndex:
        for ( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

            TrendDalta[ LoopIndex ]  =  MacdLine[ LoopIndex ] - MacdSignal[ LoopIndex ];

            if( TrendDalta[ LoopIndex ] > 0 ) {
                UpHistogram   [ LoopIndex ]  =  TrendDalta[ LoopIndex ];
                DownHistogram [ LoopIndex ]  =  EMPTY_VALUE;
            } else if( TrendDalta[ LoopIndex ] < 0 ) {
                UpHistogram   [ LoopIndex ]  =  EMPTY_VALUE;
                DownHistogram [ LoopIndex ]  =  TrendDalta[ LoopIndex ];
            } else {
                UpHistogram   [ LoopIndex ]  =  EMPTY_VALUE;
                DownHistogram [ LoopIndex ]  =  EMPTY_VALUE;
            } // End If, TrendDalta:  

        } // End For Loop, LoopIndex:




    // <<<< Segment 440 >>>> 
        // Code block to analyze price action. CN!{example ONLY, of an analitical code block}:

        for( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

            if( TrendDalta[ LoopIndex ] > UnDetermined ) {
                if( UpHistogram[ LoopIndex ] >= UpHistogram[ LoopIndex + 1 ] ) {
                    TrendAnalysis[ LoopIndex ]  =  UpTrend;
                } else {
                    TrendAnalysis[ LoopIndex ]  =  UpTrendPullBack;
                } // End If, UpHistogram:
            } else if( TrendDalta[ LoopIndex ] < UnDetermined ) {
                if( DownHistogram[ LoopIndex ] <= DownHistogram[ LoopIndex + 1 ] ) {
                    TrendAnalysis[ LoopIndex ]  =  DownTrend;
                } else {
                    TrendAnalysis[ LoopIndex ]  =  DownTrendRailly;
                } // End If, DownHistogram:
            } else {
                TrendAnalysis[ LoopIndex ]  =  UnDetermined;
            } // End If, UpHistogram:

            if( Stochastic[ LoopIndex ] > StochasticSignal[ LoopIndex ] ) {
               if( TrendAnalysis[ LoopIndex ]  ==  UpTrend ) {
                    SignalAnalysis[ LoopIndex ]  =  LONG;
                } else {
                    SignalAnalysis[ LoopIndex ]  =  FLAT;
                } // End If, TrendAnalysis:
            } else if( Stochastic[ LoopIndex ] < StochasticSignal[ LoopIndex ] ) {
                if( TrendAnalysis[ LoopIndex ]  ==  DownTrend ) {
                    SignalAnalysis[ LoopIndex ]  =  SHORT;
                } else {
                    SignalAnalysis[ LoopIndex ]  =  FLAT;
                } // End If, TrendAnalysis:
            } // End If, Stochastic:

        } // End For Loop, LoopIndex:




    // <<<< Segment 450 >>>> 
        // Creation of special arrays and buffer controls.

        for( LoopIndex = 0; LoopIndex < BarsToCalculate; LoopIndex = LoopIndex + 1 ) {

            ErrorLevel  [ LoopIndex ]  =  UnknownErrorFlag;
            EraseBuffer [ LoopIndex ]  =  EMPTY_VALUE;

        } // End For Loop, LoopIndex:




//
//    OUTPUT DIVISION    
//

// LABEL 700  SYSTEM PERFORMANCE STATISTICS: 




// LABEL 800  GRAPHIC DISPLAY AND COMMENTARY: 

    // <<<< Segment 810 >>>> 
        // Rotating indicator drawing switch, determines which indicator to expose on the chart.

// extern string QuickLegend_Ind.Lock  =  "0all 1RSI 2CCI 3MFI 4Sto 5Dem 6WPR 7RVI 8ATR 9MACD 10PA";

        if( ViewIndicators ) {
            switch( Alternate( IndicatorsExposed, AvailableIndicators, IndicatorViewTime )) {

                case RelativeStrengthIndex:
                    IndicatorName  =  ". 1:    RSI ("+RSI_Period+")    ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, MidnightBlue );
                    SetIndexLabel( Primary, "RSI Study1" );
                        FillBuffer( PrimaryIndicator, RelativeStrength, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_SOLID, 1, DarkSlateGray );
                    SetIndexLabel( LineOne, "70 Over Bought" );
                         DrawLine( LevelOne, 70, ChartDrawingBars );
                    SetIndexStyle( LineTwo, DRAW_LINE, STYLE_SOLID, 1, DarkSlateGray );
                    SetIndexLabel( LineTwo, "50 Mid Point" );
                         DrawLine( LevelTwo, 50, ChartDrawingBars );
                    SetIndexStyle( LineThree, DRAW_LINE, STYLE_SOLID, 1, DarkSlateGray );
                    SetIndexLabel( LineThree, "30 Over Sold" );
                         DrawLine( LevelThree, 30, ChartDrawingBars );
                    break;

                case CommodityChannelIndex:
                    IndicatorName  =  ". 2:    CCI ("+CCI_Period+")    ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, DodgerBlue );
                    SetIndexLabel( Primary, "CCI Study2" );
                       FillBuffer( PrimaryIndicator, CommodityChannel, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_DASHDOTDOT, 1,   DarkGreen );
                    SetIndexLabel( LineOne, "+250 Line" );
                         DrawLine( LevelOne, 250, ChartDrawingBars );
                    SetIndexStyle( LineTwo, DRAW_LINE, STYLE_DOT, 1,SeaGreen );
                    SetIndexLabel( LineTwo, "+100 Line" );
                         DrawLine( LevelTwo, 100, ChartDrawingBars );
                    SetIndexStyle( LineThree, DRAW_LINE, STYLE_DOT, 1, SeaGreen );
                    SetIndexLabel( LineThree, "-100 Line" );
                         DrawLine( LevelThree, -100, ChartDrawingBars );
                    SetIndexStyle( LineFour, DRAW_LINE, STYLE_DASHDOTDOT, 1,  DarkGreen   );
                    SetIndexLabel( LineFour, "-250 Line" );
                         DrawLine( LevelFour, -250, ChartDrawingBars );
                    break;

                case MoneyFlowIndex:
                    IndicatorName  =  ". 3:    MFI  ("+MFI_Period+")   ";
                    SetIndexStyle( Primary,   DRAW_LINE, STYLE_SOLID, 1, SpringGreen );
                    SetIndexLabel( Primary,   "MFI Study3" );
                       FillBuffer( PrimaryIndicator,   MoneyFlow, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_DOT, 1, Green );
                    SetIndexLabel( LineOne, "70 Line" );
                         DrawLine( LevelOne, 70, ChartDrawingBars );
                    SetIndexStyle( LineTwo, DRAW_LINE, STYLE_DOT, 1, DarkSlateGray );
                    SetIndexLabel( LineTwo, "50 Line" );
                         DrawLine( LevelTwo, 50, ChartDrawingBars );
                    SetIndexStyle( LineThree, DRAW_LINE, STYLE_DOT, 1, Green );
                    SetIndexLabel( LineThree, "30 Line" );
                         DrawLine( LevelThree, 30, ChartDrawingBars );
                    break;

                case SlowStochastic:
                    IndicatorName  =  ". 4:    Stochastic  ("+Sto_Percent_K+", "+Sto_Percent_D+", "+Sto_Slowing+")   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, Green );
                    SetIndexLabel( Primary, "Stochastic Study4" );
                       FillBuffer( PrimaryIndicator, Stochastic, ChartDrawingBars );
                    SetIndexStyle( Secondary, DRAW_LINE, STYLE_SOLID,  1, Red );
                    SetIndexLabel( Secondary, "Stochastic Signal Line" );
                       FillBuffer( SecondaryIndicator, StochasticSignal, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_SOLID, 1, CadetBlue );
                    SetIndexLabel( LineOne, "Over Bought" );
                         DrawLine( LevelOne, 80, ChartDrawingBars );
                    SetIndexStyle( LineTwo, DRAW_LINE, STYLE_SOLID, 1, CadetBlue );
                    SetIndexLabel( LineTwo, "Over Sold" );
                         DrawLine( LevelTwo, 20, ChartDrawingBars );
                    break;

                case DeMarkerIndicator:
                    IndicatorName  =  ". 5:    DeMarker  ("+DEM_Period+")   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 2, Gold );
                    SetIndexLabel( Primary, "DEM Study5" );
                       FillBuffer( PrimaryIndicator, DeMarker, ChartDrawingBars );
                   break;

                case WilliamPercentR:
                    IndicatorName  =  ". 6:    Williams %R  ("+WPR_Period+")   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, PaleGreen );
                    SetIndexLabel( Primary, "WPR Study6" );
                       FillBuffer( PrimaryIndicator, PercentR, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_SOLID, 1, DimGray );
                    SetIndexLabel( LineOne, "-80 Line" );
                         DrawLine( LevelOne, -80, ChartDrawingBars );
                    SetIndexStyle( LineTwo, DRAW_LINE, STYLE_DASH, 1, DimGray );
                    SetIndexLabel( LineTwo, "-50 Line" );
                         DrawLine( LevelTwo, -50, ChartDrawingBars );
                    SetIndexStyle( LineThree, DRAW_LINE, STYLE_SOLID, 1, DimGray );
                    SetIndexLabel( LineThree, "-20 Line" );
                         DrawLine( LevelThree, -20, ChartDrawingBars );
                    break;

                case RelativeVigorIndex:
                    IndicatorName  =  ". 7:    Relative Vigor Index  ("+RVI_Period+")   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, CornflowerBlue );
                    SetIndexLabel( Primary, "RVI Study Line7" );
                       FillBuffer( PrimaryIndicator, RelativeVigor, ChartDrawingBars );
                    SetIndexStyle( Secondary, DRAW_LINE, STYLE_DOT, 1, Purple );
                    SetIndexLabel( Secondary, "RVI Signal Line" );
                       FillBuffer( SecondaryIndicator, RelativeVigorSignal, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_SOLID, 1, DimGray );
                    SetIndexLabel( LineOne, "The Zero Line" );
                         DrawLine( LevelOne, 0, ChartDrawingBars );
                    break;

                case VolatilityIndicator:
                    IndicatorName  =  ". 8:    Average True Range  ("+ATR_Period+")   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, Bisque );
                    SetIndexLabel( Primary, "ATR Study8" );
                       FillBuffer( PrimaryIndicator, PriceVolatility, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_DOT, 1, FireBrick );
                    SetIndexLabel( LineOne, "No Trade Zone" );
                         DrawLine( LevelOne, NoTradeZone, ChartDrawingBars );
                    break;

                case MacdIndicator:
                    if( MACD_Histogram ) {
                        IndicatorName  =  ". 9:    MACD Histo. OsMA ("+Short_MA_Period+"."+Long_MA_Period+"."+Signal_Period+")  ";
                        SetIndexStyle( Primary, DRAW_HISTOGRAM, STYLE_SOLID, 2, LawnGreen );
                        SetIndexLabel( Primary, "MACD UP Histogram" );
                           FillBuffer( PrimaryIndicator, UpHistogram, ChartDrawingBars );
                        SetIndexStyle( Secondary, DRAW_HISTOGRAM, STYLE_SOLID, 2, Tomato );
                        SetIndexLabel( Secondary, "MACD Down Histogram" );
                           FillBuffer( SecondaryIndicator, DownHistogram, ChartDrawingBars );
                    } else { 
                        IndicatorName  =  ". 9:    MACD Indicator ("+Short_MA_Period+"."+Long_MA_Period+"."+Signal_Period+")   ";
                        SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 1, Lime );
                        SetIndexLabel( Primary, "MACD Study Line" );
                           FillBuffer( PrimaryIndicator, MacdLine, ChartDrawingBars );
                        SetIndexStyle( Secondary, DRAW_LINE, STYLE_SOLID, 1, Red );
                        SetIndexLabel( Secondary, "MACD Signal Line" );
                           FillBuffer( SecondaryIndicator, MacdSignal, ChartDrawingBars );
                    } // End If, MACD_Histogram:
                    break;

                case PriceAnalysis:
                    IndicatorName  =  ". 10:    Price Action Analysis   ";
                    SetIndexStyle( Primary, DRAW_LINE, STYLE_SOLID, 2, ForestGreen );
                    SetIndexLabel( Primary, "Signal Analysis10" );
                       FillBuffer( PrimaryIndicator, SignalAnalysis, ChartDrawingBars );
                    SetIndexStyle( Secondary, DRAW_LINE, STYLE_SOLID, 1, White );
                    SetIndexLabel( Secondary, "Trend Analysis" );
                       FillBuffer( SecondaryIndicator, TrendAnalysis, ChartDrawingBars );
                    SetIndexStyle( LineOne, DRAW_LINE, STYLE_DOT, 1, DarkSeaGreen );
                    SetIndexLabel( LineOne, "Action Line" );
                         DrawLine( LevelOne, 0, ChartDrawingBars );
                    break;

                default:
                    IndicatorName  =  " Fatal OverFlow Error.  ";
                    ConveyMessage  =  336.50;
                    if( DeBugMessages )
                        Print( ProgramName, ", OverFlow Error: Found In Indicator Switch ",
                               "Code Block. [ ", ErrorFound, " ]." );
                    break;

            } // End Switch, Alternate:
        } // End If, ViewIndicators:

        IndicatorShortName( ProgramName + IndicatorName );




// LABEL 900  COMMUNICATIONS AND LOGS TRANSMITTAL: 

    // <<<< Segment 910 >>>> 
        // Indicator Quarry switch, will delivers indicator results to a calling Expert Avisor.


        if( AllowEAsAccess ) {
            switch( IndicatorQuary ) {

                case UnDetermined:
                        break;

                case RelativeStrengthIndex:
                        FillBuffer( QuarryIndicator, RelativeStrength, ChartDrawingBars );
                        break;

                case CommodityChannelIndex:
                        FillBuffer( QuarryIndicator, CommodityChannel, ChartDrawingBars );
                        break;

                case MoneyFlowIndex:
                        FillBuffer( QuarryIndicator,   MoneyFlow, ChartDrawingBars );
                        break;

                case SlowStochastic:
                        FillBuffer( QuarryIndicator, Stochastic, ChartDrawingBars );
                        break;

                case DeMarkerIndicator:
                        FillBuffer( QuarryIndicator, DeMarker, ChartDrawingBars );
                        break;

                case WilliamPercentR:
                        FillBuffer( QuarryIndicator, PercentR, ChartDrawingBars );       
                        break;

                case RelativeVigorIndex:
                        FillBuffer( QuarryIndicator, RelativeVigor, ChartDrawingBars );
                        break;

                case VolatilityIndicator:
                        FillBuffer( QuarryIndicator, PriceVolatility, ChartDrawingBars );
                        break;

                case MacdIndicator:
                        FillBuffer( QuarryIndicator, MacdLine, ChartDrawingBars );
                        break;

                case PriceAnalysis:
                        FillBuffer( QuarryIndicator, SignalAnalysis, ChartDrawingBars );
                        break;

                default:
                    ConveyMessage  =  336.60;
                    FillBuffer( QuarryIndicator, ErrorLevel, ChartDrawingBars );
                    if( DeBugMessages )
                        Print( ProgramName, ", OverFlow Error:, In Buffer Count. [ ",
                               ErrorFound, " ]" );
                    break;
            } // End Switch, IndicatorQuary:

        } else if( ! AllowEAsAccess && IndicatorQuary > 0 ) {
            ConveyMessage  =  340.22;
            if( DeBugMessages )
                Print( ProgramName, ", EA Access Error: An Expert Is Attempting Access ",
                       "When Expert Access Is Not Permitted. [ ", ErrorFound, " ]" );
        } // End If, AllowEAsAccess:





return;}//
//    TERMINATION DIVISION     
int deinit( int Reason = 0 ){//


//  INDICATOR PERFORMANCE SECTION: 




//  INDICATOR DEINITIALIZATION SECTION: 




return;}//
//    PROCEDURAL DEFINITION DIVISION    
//


/*===============================================================================================|\
||                                                                                               ||
||        CreateCustomBuffer Routine Procedure    v1.00.01   Date 03.03.2007      KTL            ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     Creates series arrays for temperary storage of indicator values.                ||
||                                                                                               ||
||  Parameters:  BufferName -- Is the array to be redimed as a series array.                     ||
||               BarCount   -- Is the size the array will be redimed too.                        ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
    void
        CreateCustomBuffer( double& BufferName[], int BarCount ) {

            ArrayResize( BufferName,         BarCount );
            ArrayInitialize( BufferName,  EMPTY_VALUE );
            ArraySetAsSeries( BufferName,        True );

        return;
    } // End Routine Procedure, CreateCustomBuffer:




/*===============================================================================================|\
||                                                                                               ||
||        FillBuffer Routine Procedure       v1.00.01       Date 03.03.2007      KTL             ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     To fill the indicator buffers with data from a temperary series array.          ||
||                                                                                               ||
||  Parameters:  Indicator -- Is the indicator output buffer to receive data.                    ||
||               ArrayData -- Is the temperary series array that holds the data to transfer.     ||
||               BarCount  -- Is the number of elements to transfer to the output buffer.        ||
||                                                                                               ||
||  Note:        This function is needed as MQ's copy function doesnot copy the zero bar of a    ||
||               series array.                                                                   ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
    void
        FillBuffer( double& Indicator[], double ArrayData[], int BarCount ) {
            int Counter  =  0;

                for( Counter = 0; Counter < BarCount; Counter = Counter + 1 ) {
                    Indicator[ Counter ]  =  ArrayData[ Counter ];
                } // End For Loop, Counter:

        return;
    } // End Routine Procedure, FillBuffer:




/*===============================================================================================|\
||                                                                                               ||
||        DrawLine Routine Procedure       v1.00.01       Date 03.22.2007      KTL               ||
||                                                                                               ||
||  Returns:     Nothing.                                                                        ||
||                                                                                               ||
||  Purpose:     This uses buffers to construct level lines accross the indicator graphics. Such ||
||               lines as overbought and oversold for RSI etc.                                   ||
||                                                                                               ||
||  Parameters:  Level     -- Is the Level output buffer that holds the value of the line.       ||
||               LineValue -- Is value is assigned to each element of the level buffer array.    ||
||               BarCount  -- Is the number of elements to contain the line value for output.    ||
||                                                                                               ||
||  Note:        This function takes the place of MQ's builtin SetLevelValue() function. If one  ||
||               uses the builtin function to construct level lines on a chart that line will    ||
||               remain on the chart and can not be removed. This will effect the chart scalling ||
||               of future indicators. So we use buffers to draw level lines on the chart these  ||
||               can be removed by assigning an EMPTY_VALUE to the elements to remove the lines. ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
    void
         DrawLine( double& Level[], double LineValue, int BarCount ) {
            int Counter  =  0;

                for( Counter = 0; Counter < BarCount; Counter = Counter + 1 ) {
                    Level[ Counter ]  =  LineValue;
                } // End For Loop, Counter:

        return;
    } // End Routine Procedure, DrawLine:




/*===============================================================================================|\
||                                                                                               ||
||        Alternate Function Procedure         v2.00.02          Date 03.15.2007        KTL      ||
||                                                                                               ||
||  Returns:     The next number that is in series that is equal to or smaller then the Maximum  ||
||               parameter.                                                                      ||
||                                                                                               ||
||  Purpose:     To rotate between a list of objects from a lest of objects. Which can be any    ||
||               thing that can be compaire as whole numbers.                                    ||
||                                                                                               ||
||  Parameters:  Number  -- Is the number from the list of objects. Zero will rotate the list.   ||
||               Maximum -- Is the maximum number of objects available to cycle too.             ||
||               Cycle   -- Is the length of time the object will remain in control.             ||
||                                                                                               ||
||  Note:        The cycle time is based on incoming tick data, therefor the cycle time may be   ||
||               longer then the the time set if the market is slow.                             ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/
    int
        Alternate( int Number, int Maximum, int Cycle = 15 ) {
            static int   WateTime  =  0;
            static int   Rotate    =  0;
                if( WateTime < TimeCurrent() ) {
                    if( Number == All ) {
                        WateTime =  ( TimeCurrent() + Cycle );
                        Rotate  =  Rotate + 1;
                        if( Rotate > Maximum ) {
                            Rotate  =  1;
                        } // End If, Rotate:
                    } else {
                        Rotate  =  Number;
                    } // End If, Number:
                } // End If, WateTime:
        return( Rotate );
    } // End Function Procedure, Alternate:




/*--End-Code--//
//    DOCUMENTATION DIVISION    
//


     PURPOSE, SCOPE, AND FUNCTION: 




     DESCRIPTION OF INDICATOR USAGE: 




     FILES DISCRIPTIONS: 




     TESTING AND SCRIP DEBUGING: 




     VERSION UPDATES: 

        Current Revisions:
            Version 1.00.01 		KTL		00-00-2009
                *	




        Future Enhancement:
                -   




     SCRIPT NOTES: 




     CODE STORAGE AREA: 



    extern string     ______________SYSTEM_SETTINGS  = " Indicator Control Parameters";
        extern int
                            Indicator_Quary    =   0,      Indicator_Lock     =   0,
                            Viewing_Time       =  10,      Chart_Bars_Drawn   = 500;


    extern string     ___________________VIEW_LEGEND  =  " Lock Indicator View",

                                Shows All Indicators     =  "   0",
                                Relative Strength Index  =  "   1",
                                Commodity Channel Index  =  "   2",
                                Money Flow Index         =  "   3",
                                Slow Stochastic          =  "   4",
                                DeMarker Indicator       =  "   5",
                                William Percent R        =  "   6",
                                Relative Vigor Index     =  "   7",
                                Volatility Indicator     =  "   8",
                                MCAD Indicator           =  "   9",
                                Price Analysis           =  "  10",

                      _________________METHOD_LEGEND  =  " MOVING AVERAGE METHOD",

                            MODE_SMA.        =  "  0 = Simple moving average",
                            MODE_EMA.        =  "  1 = Exponential moving average",
                            MODE_SMMA.       =  "  2 = Smoothed moving average",
                            MODE_LWMA.       =  "  3 = Linear weighted moving average",

                      __________________PRICE_LEGEND  =  " PRICE STUDY MODE",
                            PRICE_CLOSE.     =  "  0 = Close price",
                            PRICE_OPEN.      =  "  1 = Open price",
                            PRICE_HIGH.      =  "  2 = High price",
                            PRICE_LOW.       =  "  3 = Low price",
                            PRICE_MEDIAN.    =  "  4 = Median price, (high+low)/2",
                            PRICE_TYPICAL.   =  "  5 = Typical price, (high+low+close)/3",
                            PRICE_WEIGHTED.  =  "  6 = Weighted price, (hi+low+cl+cl)/4";


    extern string     __________________INDICATOR_1  =  " Relative Strength Index";
        extern int
                            RSI_Period         =  13,      RSI_PriceMode     =   0;

    extern string     __________________INDICATOR_2  =  " Commodity Channel Index";
        extern int
                            CCI_Period         =  13,      CCI_PriceMode     =   0;

    extern string     __________________INDICATOR_3  =  " Money Flow Index";
        extern int
                            MFI_Period         =  13; 

    extern string     __________________INDICATOR_4  =  " Slow Stochastic";
        extern int
                            Sto_Percent_K      =  14,      Sto_Percent_D     =   3,
                            Sto_Slowing         =   3,      Sto_Price_Mode    =   0,
                            Sto_MA_Method      =   0;

    extern string     __________________INDICATOR_5  =  " DeMarker Indicator";
        extern int
                            DEM_Period         =  13; 

    extern string     __________________INDICATOR_6  =  " William Percent R";
        extern int
                            WPR_Period         =  13; 

    extern string     __________________INDICATOR_7  =  " Relative Vigor Index";
        extern int
                            RVI_Period         =  13; 

    extern string     __________________INDICATOR_8  =  " Volatility Indicator";
        extern int
                            ATR_Period         =  13,      ATR_MA_Method     =   0;

    extern string     __________________INDICATOR_9  =  " MCAD Indicator";
        extern int
                            Short_MA_Period    =  12,      Long_MA_Period    =  26,
                            Signal_Period      =   9,      Price_Mode        =   0;
        extern bool
                            MACD_Histogram     =  False;




/*===============================================================================================|\
||                                                                                               ||
||  Public- Private- Routine- Function- Procedure- Property    v1.00   Date 00.00.2009     KTL   ||
||                                                                                               ||
||  Returns:     None                                                                            ||
||                                                                                               ||
||  Purpose:     None                                                                            ||
||                                                                                               ||
||  Parameters:  None                                                                            ||
||                                                                                               ||
||  Note:        None                                                                            ||
||                                                                                               ||
||  Example:     None                                                                            ||
||                                                                                               ||
\|-----------------------------------------------------------------------------------------------*/



//
//    END PROGRAM SCRIPT;        MetaQuote Source Code [ mq4 ]    
// [rev.01-01-07] */

